package com.rebusland.fin.derivatives.eq.server.output.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.google.common.collect.ImmutableList;
import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;

import java.util.List;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class StatisticalResults extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final List<Double> moments;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code StatisticalResults}.
	 * @return the meta-bean, not null
	 */
	public static StatisticalResults.Meta meta() {
		return StatisticalResults.Meta.INSTANCE;
	}

	static {
		MetaBean.register(StatisticalResults.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static StatisticalResults.Builder builder() {
		return new StatisticalResults.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected StatisticalResults(StatisticalResults.Builder builder) {
		JodaBeanUtils.notNull(builder.moments, "moments");
		this.moments = ImmutableList.copyOf(builder.moments);
	}

	@Override
	public StatisticalResults.Meta metaBean() {
		return StatisticalResults.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the moments.
	 * @return the value of the property, not null
	 */
	public List<Double> getMoments() {
		return moments;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			StatisticalResults other = (StatisticalResults) obj;
			return JodaBeanUtils.equal(moments, other.moments);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(moments);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(64);
		buf.append("StatisticalResults{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("moments").append('=').append(JodaBeanUtils.toString(moments)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code StatisticalResults}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code moments} property.
		 */
		@SuppressWarnings({"unchecked", "rawtypes" })
		private final MetaProperty<List<Double>> moments = DirectMetaProperty.ofImmutable(
				this, "moments", StatisticalResults.class, (Class) List.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"moments");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 1235271283:  // moments
					return moments;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public StatisticalResults.Builder builder() {
			return new StatisticalResults.Builder();
		}

		@Override
		public Class<? extends StatisticalResults> beanType() {
			return StatisticalResults.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code moments} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<List<Double>> moments() {
			return moments;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 1235271283:  // moments
					return ((StatisticalResults) bean).getMoments();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code StatisticalResults}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<StatisticalResults> {

		private List<Double> moments = ImmutableList.of();

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(StatisticalResults beanToCopy) {
			this.moments = ImmutableList.copyOf(beanToCopy.getMoments());
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 1235271283:  // moments
					return moments;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@SuppressWarnings("unchecked")
		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 1235271283:  // moments
					this.moments = (List<Double>) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public StatisticalResults build() {
			return new StatisticalResults(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the moments.
		 * @param moments  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder moments(List<Double> moments) {
			JodaBeanUtils.notNull(moments, "moments");
			this.moments = moments;
			return this;
		}

		/**
		 * Sets the {@code moments} property in the builder
		 * from an array of objects.
		 * @param moments  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder moments(Double... moments) {
			return moments(ImmutableList.copyOf(moments));
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(64);
			buf.append("StatisticalResults.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("moments").append('=').append(JodaBeanUtils.toString(moments)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
